//Bildunterschriften_506d.js
// 02.05.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Versieht Bilder mit Unterschriften

//Credits
//Eine Erweiterung des Adobe-Scripts "LabelGraphics.jsx"
//Initiant: Kai Rbsamen, D-35447 Reiskirchen, www.ruebiarts.de

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die Programmversion feststellen
var appVers = parseInt(app.version.slice(0,2));
if (appVers < 7) {
	alert ("Dieses Script nur mit InDesign CS5 (oder hher) benutzen.", "Stop");
	exit();
}

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// die Plattform feststellen
if ($.os.slice(0,7) == "Windows") {
	curSys = "Win";
}
else {
	curSys = "Mac";
}

var curDoc = app.documents[0];

if (curDoc.allGraphics.length == 0) {
	alert ("Das Dokument enthlt keine Bilder.", "Stop");
	exit();
}

// die Auswahl speichern und prfen
var aSel = false;
var curSel = app.selection;
if (curSel.length == 0) {
	var allLabels = curDoc.textFrames.everyItem().label;
	for (var i=0; i<allLabels.length; i++) {
		if (allLabels[i] == "BU") {
			alert ("Zuerst alle Bildunterschrift-Rahmen entfernen.", "Stop");
			exit();
		}
	}
	var graphicsList = curDoc.allGraphics;
}
else {
	var aSel = true;
	var nItems = curSel.length;
	var curItem;
	var tmpList;
	var graphicsList = new Array ();
	for (var i=0; i<nItems; i++) {
		curItem = curSel[i];
		if (curItem.constructor.name == "Rectangle") {
			graphicsList.push(curItem.allGraphics[0]);
		}
		else if (curItem.constructor.name == "Group") {
			tmpList = curItem.allGraphics;
			for (var k=0; k<tmpList.length; k++) {
				graphicsList.push(tmpList[k]);
			}
		}
	}
}

// Variablen initialisieren
var labelType = 0;
var frameHeight = 8;
var frameOffset = 0;
var rndUnit = 3;
var paraStyle = objtStyle = "";
var pStyle = oStyle = 0;
var iLay = true;

// die Datei lesen, in welcher die letzte Auswahl gespeichert ist
var labelDef = getDefs();
// die gespeicherten Werte ausziehen
if (labelDef != "") {
	var defVal = labelDef.split("\n");
	labelType = defVal[0]*1;
	frameHeight = defVal[1]*1;
	frameOffset = defVal[2]*1;
	rndUnit = defVal[3];
	if      (rndUnit == "0")  { rndUnit = 0; }
	else if (rndUnit == "1")  { rndUnit = 1; }
	else if (rndUnit == "2")  { rndUnit = 2; }
	else if (rndUnit == "4")  { rndUnit = 3; }
	else if (rndUnit == "5")  { rndUnit = 4; }
	else if (rndUnit == "10") { rndUnit = 5; }
	paraStyle = defVal[4];
	objtStyle = defVal[5];
	iLay = defVal[6];
	if (iLay == "true") {iLay = true;}
	else {iLay = false;}
}

// Dialog vorbereiten, anzeigen und auswerten
var labelWidth = 110;
var menuWidth = 250;
var labelList = new Array ("Dateiname", "Dateiname ohne Suffix", "Dateipfad", "XMP-Beschreibung", "XMP-Autor");
var styleNames = getParagraphStyleNames();
var nStyles = styleNames.length;
for (var i=0; i<nStyles; i++) {
	if (styleNames[i] == paraStyle) {
		pStyle = i;
		break;
	}
}
var objectNames = getObjectStyleNames();
var nStyles = objectNames.length;
for (var i=0; i<nStyles; i++) {
	if (objectNames[i] == objtStyle) {
		oStyle = i;
		break;
	}
}
var rndUnits = new Array ("", "1", "0.5", "0.25", "0.2", "0.1");
var rndValues = new Array (0, 1, 2, 4, 5, 10);

// Dialoge lschen
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

var aDialog = app.dialogs.add({name:"Bildunterschriften"});
with (aDialog.dialogColumns.add()) {
	// Art der Bildunterschrift
	with(dialogRows.add()) {
		with(dialogColumns.add()) {
			staticTexts.add({staticLabel:"Inhalt", minWidth:labelWidth});
		}
		with(dialogColumns.add()) {
			var labelTypeDropdown = dropdowns.add({stringList:labelList, selectedIndex:labelType, minWidth:menuWidth});
		}
	}
	// Textrahmenhhe und -versatz
	with(dialogRows.add()) {
		with(dialogRows.add()) {
			staticTexts.add({staticLabel:"Rahmenhhe", minWidth:labelWidth});
			var labelHeightField = realEditboxes.add();
			labelHeightField.properties = {editValue:frameHeight, minimumValue:1, maximumValue:99, minWidth:36};
			staticTexts.add({staticLabel:"mm"});
			staticTexts.add({staticLabel:"Versatz", minWidth:80});
			var labelOffsetField = realEditboxes.add({editValue:frameOffset, minWidth:36});
			staticTexts.add({staticLabel:"mm"});
		}
	}
	// Rundungseinheit
	with(dialogRows.add()) {
		with(dialogRows.add()) {
			staticTexts.add({staticLabel:"Rundungseinheit", minWidth:labelWidth});
			var labelRoundDropdown = dropdowns.add({stringList:rndUnits, selectedIndex:rndUnit, minWidth:39});
			staticTexts.add({staticLabel:"  (wenn bersatz)"});
		}
	}
	// Absatzformat
	with(dialogRows.add()) {
		with(dialogRows.add()) {
			with(dialogColumns.add()) {
				staticTexts.add({staticLabel:"Absatzformat", minWidth:labelWidth});
			}
			with(dialogColumns.add()) {
				var labelStyleDropdown = dropdowns.add({stringList:styleNames, selectedIndex:pStyle, minWidth:menuWidth});
			}
		}
	}
	// Objektformate
	with(dialogRows.add()) {
		with(dialogColumns.add()) {
			staticTexts.add({staticLabel:"Objektformat", minWidth:labelWidth});
		}
		with(dialogColumns.add()) {
			var objectStyleDropdown = dropdowns.add({stringList:objectNames, selectedIndex:oStyle, minWidth:menuWidth});
		}
	}
	// Checkbox BU eigene Ebene
	with(dialogRows.add()) {
		staticTexts.add({staticLabel:"", minWidth:labelWidth});
		var layerCheckbox = checkboxControls.add({staticLabel:"Bildunterschriften auf eigener Ebene", checkedState:iLay});
	}
	with (aDialog.dialogColumns.add()) {
		staticTexts.add({staticLabel:"", minWidth:4});
	}
}
var dResult = aDialog.show();
if(dResult == true) {
	var labelType = labelTypeDropdown.selectedIndex;
	var labelHeight = labelHeightField.editValue;
	var labelOffset = labelOffsetField.editValue;
	var rndVal = rndValues[labelRoundDropdown.selectedIndex];
	var labelStyle = styleNames[labelStyleDropdown.selectedIndex];
	var objectStyle = objectNames[objectStyleDropdown.selectedIndex];
	var indLayer = layerCheckbox.checkedState;
	aDialog.destroy();
}
else{
	aDialog.destroy();
	exit();
}

// das Ergebnis in eine Datei schreiben
var labelDef = ("" + labelType + "\n" + labelHeight + "\n" + labelOffset + "\n" 
+ rndVal + "\n" + labelStyle + "\n" + objectStyle + "\n" + indLayer);
writeDefs(labelDef);

// die Masseinheiten speichern
// wenn nicht 2053991795 (= Millimeter), auf Millimeter umstellen
hM = (curDoc.viewPreferences.horizontalMeasurementUnits)*1;
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}
vM = (curDoc.viewPreferences.verticalMeasurementUnits)*1;
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}

// den Ursprung der Linealeinheiten auf "Druckbogen" setzen
var rO = (curDoc.viewPreferences.rulerOrigin)*1;
if (rO != 1380143983) {
	curDoc.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
}

// den Referenzpunkt auf "oben Mitte" setzen
var trp = (app.layoutWindows[0].transformReferencePoint)*1;
if (trp != 1095660643) {
	app.layoutWindows[0].transformReferencePoint = 1095660643;
}

// die Funktion zum Erzeugen der Bildunterschriften aufrufen
addLabels (labelType, labelHeight, labelOffset, rndVal, labelStyle, objectStyle);

// die Masseinheiten zurcksetzen
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = hM;
}
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = vM;
}

// den Ursprung der Linealeinheiten zurcksetzen
if (rO != 1380143983) {
	try {
		curDoc.viewPreferences.rulerOrigin = rO;
	}
	catch (e) {
	}
}

// den Referenzpunkt zurcksetzen
if (trp != 1095660643) {
	app.layoutWindows[0].transformReferencePoint = trp;
}

// die Funktion, welche die Bildunterschriften erzeugt
function addLabels(labelType, labelHeight, labelOffset, rndVal, labelStyleName, objectStyleName) {
	var actLayer = app.activeWindow.activeLayer;
	if (indLayer) {
		// die BU-Ebene erzeugen (falls sie nicht vorhanden ist)
		var labelLayer = curDoc.layers.item("BU");
		try { 
			labelLayer.name;
		}
		catch (e) {
			labelLayer = curDoc.layers.add();
			labelLayer.name = "BU";
		}
		app.activeWindow.activeLayer = labelLayer;
	}
	var curLayer = app.activeWindow.activeLayer;
	// die Sperrung der Ebenen speichern und aufheben (falls notwendig)
	var allLayers = curDoc.layers;
	var nLayers = allLayers.length;
	var layerLocks = new Array ();
	for (var i=0; i<nLayers; i++) {
		if (allLayers[i].locked == true) {
			allLayers[i].locked = false;
			layerLocks.push(true);
		}
		else {
			layerLocks.push(false);
		}
	}
	// verschiedene Variablen vorbereiten
	labelStyle = curDoc.paragraphStyles.item(labelStyleName);
	objectStyle = curDoc.objectStyles.item(objectStyleName);
	var objSt = false;
	var curFrame, curLabel, curGraphic, curLink, curTextFrame, curPage, tmpFrame, tmpGroup;
	var testPar, pgNum, targetLoc, diff, lastBase, rot, lock, tmp;
	var vB, y1, x1, x2, bH, iS, vJ, bIns, allLabels, xvB;
	var curHeight, tstVal, intVal, decVal, rndVal, defHeight;
	// eine Schleife durch die Liste der Bilder
	for (var ctr=0; ctr<graphicsList.length; ctr++) {
		tmp = false;
		curGraphic = graphicsList[ctr];
		try {
			testPar = curGraphic.parent.parent.constructor.name;
			if (testPar == "Page" || testPar == "Spread" || testPar == "Group") {
				curLink = curGraphic.itemLink;
				// 'labelType' definiert den Text der Bildunterschrift
				if (labelType == 0) {
					curLabel = curLink.name; // Dateiname
					if (curLabel.match(".pdf") || curLabel.match(".PDF")) {
						pgNum = curGraphic.pdfAttributes.pageNumber;
						if (pgNum > 1) {
							curLabel = curLabel + ":" + pgNum;
						}
					}
				}
				else if (labelType == 1) {
					curLabel = curLink.name; // Dateiname
					if (curLabel.match(".pdf") || curLabel.match(".PDF")) {
						curLabel = curLabel.slice(0,-4); // Suffix abschneiden
						pgNum = curGraphic.pdfAttributes.pageNumber;
						if (pgNum > 1) {
							curLabel = curLabel + ":" + pgNum;
						}
					}
					else {
						lastPos = curLabel.lastIndexOf(".");
						if (lastPos != -1) {
							allChars = curLabel.length;
							if ((allChars - lastPos) > 2 || (allChars - lastPos) < 6) {
								curLabel = curLabel.slice(0,lastPos); // Suffix abschneiden
							}
						}
					}
				}
				else if (labelType == 2) {
					curLabel = curLink.filePath; // Dateipfad
					if (curLabel.match(".pdf") || curLabel.match(".PDF")) {
						pgNum = curGraphic.pdfAttributes.pageNumber;
						if (pgNum > 1) {
							curLabel = curLabel + ":" + pgNum;
						}
					}
				}
				else if (labelType == 3) {
					try {
						curLabel = curLink.linkXmp.description; // XMP-Beschreibung
					}
					catch (e) {
						curLabel = "";
					}
				}
				else if (labelType == 4) {
					try {
						curLabel = curLink.linkXmp.author; // XMP-Autor
					}
					catch (e) {
						curLabel = "";
					}
				}
				// der Rahmen des aktuellen Bildes
				curFrame = curGraphic.parent;
				rot = curFrame.rotationAngle;
				// wenn der Drehwinkel nicht Null ist
				if (rot != 0) {
					testPar = curFrame.parent.constructor.name;
					// wenn der Parent des Rahmens "Seite" oder "Druckbogen" ist ...
					if (testPar == "Page" || testPar == "Spread") {
						// ... die Verriegelung prfen ...
						if (curFrame.locked == true) { 
							lock = true; 
							curFrame.locked = false; 
						}
						// ... den Drehwinkel auf Null setzen
						curFrame.rotationAngle = 0;
					}
					// ... sonst ist der Rahmen gruppiert und es wird eine temporre Kopie davon gemacht
					else {
						tmp = true;
						tmpFrame = curFrame.duplicate();
						tmpFrame.rotationAngle = 0;
					}
					app.activeWindow.activeLayer = curFrame.itemLayer;
				}
				// die Position speichern, je nachdem ob Kopie oder nicht
				if (!tmp) {
					vB = curFrame.visibleBounds;
				}
				else {
					vB = tmpFrame.visibleBounds;
				}
				// die Positionen des BU-Rahmens ausrechnen
				y1 = vB[2] + labelOffset;
				x1 = vB[1];
				x2 = vB[3];
				if (!tmp) {
					targetLoc = curFrame.parent;
				}
				else {
					targetLoc = tmpFrame.parent;
				}
				// eine Schleife, um bei Gruppierungen die Seite oder den Druckbogen feststellen zu knnen
				for (var p=0; p<10; p++) {
					testPar = targetLoc.constructor.name;
					if (testPar == "Page" || testPar == "Spread") {
						// prfen, ob sich ein BU-Rahmen an dieser Position befindet ...
						if (aSel) {
							try {
								var frameList = new Array ();
								allLabels = targetLoc.textFrames.everyItem().label;
								for (var i=0; i<allLabels.length; i++) {
									if (allLabels[i] == "BU") {
										frameList.push(targetLoc.textFrames[i]);
									}
								}
								for (x=0; x<frameList.length; x++) {
									xvB = frameList[x].visibleBounds;
									if (xvB[0] > (y1-1) && xvB[0] < (y1+1)) {
										if (xvB[1] > (x1-1) && xvB[1] < (x1+1)) {
											try {
												if (frameList[x].locked == true) {
													frameList[x].locked = false;
												}
												frameList[x].remove(); // ... und lschen
											}
											catch (e) {
											}
											break;
										}
									}
								}
							}
							catch (e) {
							}
						}
						curTextFrame = targetLoc.textFrames.add({visibleBounds:[y1, x1, y1+10, x2], contents:curLabel, label:"BU"});
						if (curLabel == "") {
							curTextFrame.parentStory.contents = "tmp";
						}
						break;
					}
					else {
						targetLoc = targetLoc.parent;
					}
				}
				// Objektformat zuweisen (oder Absatzformat und die erste Grundlinie einstellen)
				if (objectStyleName[0] == "[") {
					curTextFrame.textFramePreferences.firstBaselineOffset = FirstBaseline.leadingOffset;
					curTextFrame.parentStory.texts.item(0).appliedParagraphStyle = labelStyle;
				}
				else {
					var objSt = true;
					curTextFrame.appliedObjectStyle = objectStyle;
				}
				curTextFrame.visibleBounds = [y1, x1, y1+100, x2];
				// den Rahmen anpassen
				curTextFrame.fit(FitOptions.FRAME_TO_CONTENT);
				// die Bounds und die vertikale Ausrichtung speichern ...
				vB = curTextFrame.visibleBounds;
				vJ = (curTextFrame.textFramePreferences.verticalJustification)*1;
				// ... und auch den Textabstand
				iS = curTextFrame.textFramePreferences.insetSpacing;
				if (iS.length == 4) {
					bIns = iS[2];
				}
				else {
					bIns = iS;
				}
				// ... und die Hhe mit der Vorgabe vergleichen
				curHeight = (vB[2]-vB[0]);
				if (curHeight <= labelHeight) { // wenn der Rahmen weniger hoch (oder gleich) ist, als gewnscht ...
					curTextFrame.visibleBounds = [y1, x1, y1+labelHeight, x2]; // ... auf die Hhe bringen
				}
				else { // wenn der Rahmen hher ist ...
					if (vJ != 1651471469 && bIns == 0 && !objSt) { // ... vertikale Ausrichtung nicht "Unten", Textabstand unten gleich Null, kein Objektformat ...
						curLead = curTextFrame.parentStory.leading;
						if (curLead != 1635019116) {
							leadHalf = (curLead/2) * 0.353;
						}
						else {
							curSize = curTextFrame.parentStory.pointSize;
							curAuto = (curTextFrame.parentStory.autoLeading)/100;
							leadHalf = ((curSize*curAuto)/2) * 0.353;
						}
						if (rndVal == 0) { // keine Rundung
							curTextFrame.visibleBounds = [y1, x1, vB[0]+curHeight+leadHalf, x2]; // der Hhe den halben Zeilenabstand zugeben
						}
						else {
							defHeight = (Math.ceil((curHeight+leadHalf)*rndVal))/rndVal; // der Hhe den halben Zeilenabstand zugeben und runden lassen
							curTextFrame.visibleBounds = [y1, x1, vB[0]+defHeight, x2];
						}
					}
					else {
						if (rndVal == 0) { // keine Rundung
							curTextFrame.visibleBounds = [y1, x1, vB[0]+curHeight, x2];
						}
						else {
							defHeight = (Math.ceil(curHeight*rndVal))/rndVal;  // die aktuelle Hhe runden lassen
							curTextFrame.visibleBounds = [y1, x1, vB[0]+defHeight, x2];
						}
					}
				}
				// wenn kein Inhalt, tmp-String entfernen
				if (curLabel == "") {
					try {
						curTextFrame.parentStory.remove();
					}
					catch (e) {
					}
				}
				// wenn der Drehwinkel nicht Null war ...
				if (rot != 0) {
					// ... Bild- und BU-Rahmen vorbergehend gruppieren ...
					curPage = curTextFrame.parent;
					if (!tmp) {
						tmpGroup = curPage.groups.add([curFrame, curTextFrame]);
					}
					else {
						tmpGroup = curPage.groups.add([tmpFrame, curTextFrame]);
					}
					// ... zurckdrehen ...
					tmpGroup.rotationAngle = rot;
					// ... und entgruppieren
					tmpGroup.ungroup();
					// den BU-Rahmen auf die Zielebene verschieben
					if (indLayer) {
						app.activeWindow.activeLayer = labelLayer;
						curTextFrame.move(labelLayer);
					}
					else {
						app.activeWindow.activeLayer = curLayer;
						curTextFrame.move(curLayer);
					}
					// eine eventuelle Kopie des Bildrahmens lschen
					if (tmp) {
						tmpFrame.remove();
					}
					// falls gesperrt, die Sperrung wiederherstellen
					if (lock) {
						curFrame.locked = true;
					}
				}
			}
		}
		catch (e) {
		}
	}
	// die Sperrung der Ebenen wiederherstellen (falls notwendig)
	for (var i=0; i<(nLayers); i++) {
		allLayers[i].locked = layerLocks[i];
	}
	// wenn mehr als eine Ebene vorhanden ist
	if (nLayers > 1) {
		// die ursprnglich ausgewhlte Ebene wieder auswhlen
		app.activeWindow.activeLayer = actLayer;
	}
}

// die Funktion, welche die Absatzformatnamen auflistet
function getParagraphStyleNames() {
	return curDoc.paragraphStyles.everyItem().name;
}

// die Funktion, welche die Objektformatnamen auflistet
function getObjectStyleNames() {
	var allObjStyles = curDoc.objectStyles.everyItem().name;
	var nStyles = allObjStyles.length;
	var selStyles = new Array ();
	var curStyle;
	for (var i=0; i<nStyles; i++) {
		curStyle = allObjStyles[i];
		if (curStyle.indexOf("Grafikrahmen]") == -1 && curStyle.indexOf("Raster]") == -1) {
			selStyles.push(curStyle);
		}
	}
	return selStyles;
}

// die Funktion, welche die Informationen vorbereitet
function getDefs() {
	var labelDef = "";
	// die Datei einlesen, welche die gespeicherten Werte enthlt
	if (curSys == "Win") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/labelDef506.txt");
	}
	else {
		var f = new File("~/Library/Preferences/labelDef506.txt");
	}
	fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			labelDef = (f.read());
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return labelDef;
}

// das Ergebnis in eine Datei schreiben
function writeDefs(labelDef) {
	if (curSys == "Win") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/labelDef506.txt");
	}
	else {
		var f = new File("~/Library/Preferences/labelDef506.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(labelDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return fileIsOpen;
}